/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   color.c                                            :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/16 18:58:49 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/16 18:58:52 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

t_color int_to_color(int c)
{
	t_color new;

	new.blu = c & 0x0000FF;
	new.grn = (c >> 8) & 0x0000FF;
	new.red = (c >> 16) & 0x0000FF;
	return (new);
}

int     color_to_int(t_color c)
{
	return ((c.red << 16) | (c.grn << 8) | c.blu);
}

t_gradient	default_gradient(void)
{
	t_gradient 	grad;

	grad.grd[0] = int_to_color(BLACK);
	grad.grd[1] = int_to_color(BLUE);
	grad.grd[2] = int_to_color(VIOLET);
	grad.grd[3] = int_to_color(INDIGO);
	grad.grd[4] = int_to_color(RED);
	grad.grd[5] = int_to_color(ORANGE);
	grad.grd[6] = int_to_color(YELLOW);
	grad.grd[7] = int_to_color(WHITE);
	return (grad);
}

t_gradient	random_gradient(void)
{
	t_gradient	grad;
	int 		i;
	t_color		c;

	i = 0;
	while (i < NUM_COLORS)
	{
		c.red = rand() % 255;
		c.grn = rand() % 255;
		c.blu = rand() % 255;
		grad.grd[i++] = c;
	}
	return (grad);
}

t_color gradient(float value, t_gradient grad)
{
	int			id1;
	int			id2;
	float		frac;
	t_color		c;

	frac = 0;
	if(value <= 0)
		id1 = id2 = 0;
	else if(value >= 1)
		id1 = id2 = NUM_COLORS - 1;
	else
	{
		value = value * (NUM_COLORS - 1);
		id1  = (int)floor(value);
		id2  = id1 + 1;
		frac = value - (float)id1;
	}
	c.red = (grad.grd[id2].red - grad.grd[id1].red) * frac + grad.grd[id1].red;
	c.blu = (grad.grd[id2].blu - grad.grd[id1].blu) * frac + grad.grd[id1].blu;
	c.grn = (grad.grd[id2].grn - grad.grd[id1].grn) * frac + grad.grd[id1].grn;
	return (c);
}

