#include "fractol.h"

void	move_down(t_fractol *fr)
{
	printf("z %Lf\n", fr->frac->mov.z);
	fr->frac->mov.y += 1.f / fr->frac->mov.z * 0.2;
	new_and_clear_image(fr);
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
}

void	move_up(t_fractol *fr)
{
	printf("z %Lf\n", fr->frac->mov.z);
	fr->frac->mov.y -= 1.f / fr->frac->mov.z * 0.2;
	new_and_clear_image(fr);
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
}

void	reset(t_fractol	*fr)
{
	fr->frac->mov.x = 0;
	fr->frac->mov.y = 0;
	fr->frac->mov.z = 1;
	fr->frac->max_itr = FRAC_MAX_ITR;
	fr->frac->grd = default_gradient();
	if (fr->frac->frac_type == 0)
		complex_equal(-0.4, 0.6, &fr->frac->com_const);
	else
		complex_equal(0, 0, &fr->frac->com_const);
	new_and_clear_image(fr);
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
}

void	change_limit_up(t_fractol *fr)
{
	fr->frac->max_itr +=50;
	new_and_clear_image(fr);
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
}

void	change_limit_down(t_fractol *fr)
{
	if (fr->frac->max_itr >= 100)
	{
		fr->frac->max_itr -= 50;
		new_and_clear_image(fr);
		parallel_fractal(fr);
		mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
	}
}