#include "fractol.h"

void	zoom_in(t_fractol *fr, int x, int y)
{
	int		center_x;
	int 	center_y;

	center_x = WIDTH / 2;
	center_y = HEIGHT / 2;
	new_and_clear_image(fr);
	fr->frac->mov.z *= 1.5;
	fr->frac->mov.x += ((float)x - center_x) / (center_x * fr->frac->mov.z) * 0.8;
	fr->frac->mov.y += ((float)y - center_y) / (center_y * fr->frac->mov.z) * 0.8;
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);

}

void	zoom_out(t_fractol *fr)
{
	new_and_clear_image(fr);
	fr->frac->mov.z /= 2;
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);

}

void	move_left(t_fractol *fr)
{
	printf("z %Lf\n", fr->frac->mov.z);
	fr->frac->mov.x -= 1.f / fr->frac->mov.z * 0.2;
	new_and_clear_image(fr);
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
}

void	move_right(t_fractol *fr)
{
	printf("z %Lf\n", fr->frac->mov.z);
	fr->frac->mov.x += 1.f / fr->frac->mov.z * 0.2;
	new_and_clear_image(fr);
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
}
